#include"logserver.h"

#include"../sys.h"

DynStr16 *the;

void log_init() {
	the = sys_vpm_map(SYS_MAP_VIRT_ANY, SYS_MAP_PHYS_ANY, 4096);
	the->len = 0;
	the->cap = 4096 - sizeof(*the);
}

void log_update(Str16 *next) {
	if(the->len + next->len > the->cap) {
		size_t fit = the->len + next->len - the->cap;
		std_move(the->data, the->data + fit, the->len - fit);
		the->len -= fit;
	}
	
	std_copy(the->data + the->len, next->data, next->len);
	
	the->len += next->len;
}

DynStr16 *log_get() {
	return the;
}
